

*
* WinNodes.inc: Setting up the data (from a previously included file
*               such as WinData.inc or WinGen.inc) in the scenario
*               tree, or node, representation.
*
* SN, GAMS Summer Schools, 2003.
*


* Set up the scenario tree structure, represented by "ancestor(n0,n)".
* It helps to differentiate between root, "middle" and leaf-nodes.
* Node n0 is the "ancestor" of node n if it's just above it in the tree.
  set ancestor(n0,n), root(n), leaf(n), middle(n);

  root(n) = YES $ (ord(n) = 1);
  leaf(n) = YES $ (ord(n) > (card(Cnodes) - card(Cscen)));
  middle(n) = YES $ (not root(n) and not leaf(n));

* Set up a correspondence from scenarios/time periods to tree nodes:
* nst(n,s,t) is YES iff scenario s at time t ends up in node n.
  set nst(n,s,t);

  nst(leaf(n),s,"t2")   = YES $ (ord(n) = ord(s) + fanout + 1);
  nst(middle(n),s,"t1") = YES $ (ord(n) = floor((ord(s)-1)/(card(Cscen)/fanout))+2);
  nst(root(n),s,"t0")   = YES;
  display nst;

  ancestor(n0,n) = YES $ sum((s,t),  nst(n0, s, t) and nst(n, s, t+1));

  display fanout, fanout2, root, middle, leaf, ancestor;

  parameter cash_yieldN(n), yieldN(i, n), liabN(n);

* cash_yieldN(n) is the yield of cast coming INTO node n, etc.
  cash_yieldN(n) = smax((t,s) $ nst(n,s,t), cash_yield(t-1, s));
  yieldN(i, n)   = smax((t,s) $ nst(n,s,t), yield(i,t-1,s));
  liabN(n)       = smax((t,s) $ nst(n,s,t), liab(t-1,s));

  display cash_yieldN, yieldN, liabN;

